#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Jun 22 11:01:02 2017

@author: thiago
"""

from treeview import mostra_arvores

class NoHeap:
    def __init__(self, a, no, fim):
        self._a = a
        self._no = no
        self._fim = fim
    
    def filhos(self):
        if 2*self._no + 1 < self._fim:
            yield NoHeap(self._a, 2*self._no + 1, self._fim)
        if 2*self._no + 2 < self._fim:
            yield NoHeap(self._a, 2*self._no + 2, self._fim)
        
    def val(self):
        return self._a[self._no]

def gera_arvores():
    a = [9, 8, 7, 3, 0, 2, 4, 2, 1]
    yield NoHeap(a, 0, len(a))

if __name__ == "__main__":
    mostra_arvores(gera_arvores())